package com.rayrobdod.commaSeparatedValues.parser

import scala.collection.mutable.StringBuilder
import scala.collection.immutable.List

/**
 * Parses a whatever into a {@link List} of List of Strings.
 * Since I have not made a Table into a scala thing yet. 
 * 
 * @author Raymond Dodge
 * @version 03 Aug 2011
 * @version 15 Dec 2011 - moved from {@code net.verizon.rayrobdod.commaSeparatedValues.parser} to {@code com.rayrobdod.commaSeparatedValues.parser}
 */
class ToSeqSeqCSVParseListener extends CSVParseListener
{
	private var parsedSoFar:List[List[String]] = Nil
	private var thisRecord:List[String] = Nil
	private var thisField:StringBuilder = StringBuilder.newBuilder
	
	def result = parsedSoFar
	
	override def abort = false
	override def started(index:Int) {
		parsedSoFar = Nil
		thisRecord = Nil
		thisField = StringBuilder.newBuilder
	}
	override def ended(index:Int) {}
	
	override def newRecord(index:Int) {
		this.newField(index)
		parsedSoFar = parsedSoFar :+ thisRecord
		thisRecord = Nil
	}
	
	override def newField(index:Int) {
		thisRecord = thisRecord :+ thisField.toString
		thisField = StringBuilder.newBuilder
	}
	
	override def readCharacter(charact:Char) {
		thisField += charact
	}
}
